/* vtest.c --- driver to test viterbi algorithm */
#include <stdio.h>
#include <malloc.h>

int viterbi(double *samples,int *bits,int n);

extern double dp0,p00,p01,p10,p11;

void main()
{
	double *samples;
	int *bits,i,numsamp;
	FILE *indat;
	
	numsamp = 999;
	while (numsamp > 124) {
		printf("Number of samples ( < 125) : ");
		scanf("%d",&numsamp);
	}
	samples=(double *)calloc(numsamp,sizeof(double));
	bits=(int *)calloc(numsamp,sizeof(int));
	
	indat=fopen("vdat.dat","rt");
	for (i=0;i<numsamp;i++) {
		fscanf(indat,"%lf",&samples[i]);
	}
	fclose(indat);

/* initialize globals */
	dp0 = p00 = p10 = 0.0;

	if (viterbi(samples,bits,numsamp) != 0) {
		printf("Error in viterbi algorithm.\n");
	}
	for (i=0;i<numsamp;i++) {
		printf("%d, ",bits[i]);
	}
	free(bits);
	free(samples);
}
